import React from 'react';

class BadWords extends React.Component {
  constructor() {
    super();
    this.state = { badWords: [] }
  }

  componentDidMount() {
    fetch('../word.json')
      .then(res => res.json())
      .then(data => this.setState({ badWords: data }))
    }
    
  render() {
    const badList = [...this.state.badWords]

    const title = (this.props.title ? this.props.title: " ");
    const description = (this.props.description ? this.props.description: " "); 
    const body = (this.props.body ? this.props.body: " ");
    const tags = (this.props.tags ? this.props.tags: " " );
    const comment = (this.props.comment ? this.props.comment: " ");
    const tag = (this.props.tagList || []).map(v => v.toLowerCase())

    const re = /[\s!#?*-_."']/

    const inputArray = [
      ...title.toLowerCase().replace(/@/g,'a').split(re),
      ...description.toLowerCase().replace(/@/g,'a').split(re),
      ...body.toLowerCase().replace(/@/g,'a').split(re),
      ...tags.toLowerCase().replace(/@/g,'a').split(re),
      ...comment.toLowerCase().replace(/@/g,'a').split(re),
      ...tag
    ];
    
    const found = this.state.badWords.some(v=> inputArray.indexOf(v) !== -1);

    const filteredBadWordsArray = inputArray.filter(bad => {
      const trimmed = bad.trim()
      return badList.indexOf(trimmed) > -1
    })

    if (found) {
      return (
        document.getElementById("publish").disabled = true,
        <ul className="error-messages">
          <li style={{paddingTop: '12px'}}>Please, clean these words to post this message: 
          {filteredBadWordsArray.map((bad, index) => <span style={{color:'#696969', fontSize: '0.8rem'}} key={index}>{' '}{'...'}{bad.toUpperCase()}{' '}</span>)}</li>
        </ul>
      )
    } else {
      try {
        return(
          document.getElementById("publish").disabled = false)
        }
      catch(err) {
          return null
        }
    }
  }}

export default BadWords
